function [nn] = dbnunfoldtonn(dbn, outputsize, x, y)
%DBNUNFOLDTONN Unfolds a DBN to a NN
%   dbnunfoldtonn(dbn, outputsize ) returns the unfolded dbn with a final
%   layer of size outputsize added.
    if(exist('outputsize','var'))
        sizez = [dbn.sizes outputsize];
    else
        sizez = [dbn.sizes];
    end
    nn = nnsetup(sizez);

    for i = 1 : numel(dbn.rbm)
        nn.W{i} = [dbn.rbm{i}.c dbn.rbm{i}.W];
    end
    
    %Performing pseudo-inverse method for regression layer initialization
    %This initializes the weights of the top layer to extreme values (~1e9)
    %Some sources suggest that the reason is the activations being too
    %small. The approach, however, is supported by many.
    %Due to this, currently initializing with random values
%     [activations, ~] = nnpredict(nn, x);
%     bias = mean(y);
% 
%     hn = activations{end-1}(5:10:end,:);
%     yr = y(5:10:end,:);
%     
%     for i = 1:size(yr,1)
%        yr(i,:) = yr(i,:) - bias; 
%     end
%     nn.W{end} = (pinv(hn)*yr)';
    
end

