function [lsf, sigA, sigacf] = getLsfParameters(input, N)
% Estimates the autocorrelation sequence for size 'N' from 'input'
% Applies a frequency warping by modifying the AC matrix
% Calculates the LSF parameters from the modified AC

%TODO: Apply the warping

    hlpc2lsf = dsp.LPCToLSF(...
            'NumCoarseGridPoints', 256);
    hacf = dsp.Autocorrelator( ...
                'MaximumLagSource', 'Property', ...
                'MaximumLag', N, ...
                'Scaling', 'Biased');
    hlevinson = dsp.LevinsonSolver( ...
                  'AOutputPort', true, ...
                  'KOutputPort', false);   
          
%     sigacf   = step(hacf, input);               % Autocorrelation
    lambda = 0.4;
    b = [-lambda 1]';
    a = [1 -lambda]';

    sig=input(:); 
    sigt=sig';
    
    sigacf(1,1)=sigt*sig; 
    wrpd=sig(:);
    for i=2:(N+1)
        wrpd=filter(b,a,wrpd);
        sigacf(1,i)=sigt*wrpd;
    end
    
    sigA = step(hlevinson, sigacf');      % Levinson-Durbin
  
    lsf = step(hlpc2lsf, sigA);
end