close all
clear
clc

matFileName = 'trainOutput';
outFileName = strcat(matFileName, '.txt');
trainFileName = 'trainfiles.txt';
testFileName = 'testfiles.txt';
validFileName = 'validationfiles.txt';

train_x = []; %output matrix for LSFs
train_y = []; %output matrix for labels

test_x = []; %output matrix for LSFs
test_y = []; %output matrix for labels

valid_x = []; %output matrix for LSFs
valid_y = []; %output matrix for labels

tic
disp('... Retrieving training data');
fid = fopen(trainFileName);
tline = fgetl(fid);

while ( ischar(tline) ) 

    i_lsf = strcat(tline, '.lsf');
    i_ema = strcat(tline, '.ema');

    [lsf, ~, ~] = estload(i_lsf);
    [ema, ~, ~] = estload(i_ema);

    for j = 1:size(lsf,1)
        for k = 1:10
            train_x = [train_x; lsf(j,(k-1)*41+1:k*41)];
            train_y = [train_y; ema(j,1:12)];
        end
    end
    t = toc;
    disp(strcat(tline, ' ... ', num2str(t)));
    tline = fgetl(fid);
end

fclose(fid);
t = toc;
disp(strcat('Training set extraction took ', num2str(t), 'seconds'));

tic
disp('... Retrieving validation data');
fid = fopen(validFileName);
tline = fgetl(fid);

while ( ischar(tline) ) 
    j_lsf = strcat(tline, '.lsf');
    j_ema = strcat(tline, '.ema');
    [lsf, ~, ~] = estload(j_lsf);
    [ema, ~, ~] = estload(j_ema);

    for j = 1:size(lsf,1)
        for k = 1:10
            valid_x = [valid_x; lsf(j,(k-1)*41+1:k*41)];
            valid_y = [valid_y; ema(j,1:12)];
        end
    end
    t = toc;
    disp(strcat(tline, ' ... ', num2str(t)));
    tline = fgetl(fid);
end

fclose(fid);
t = toc;
disp(strcat('Validation set extraction took ', num2str(t), ' seconds'));

tic
disp('... Retrieving test data');
fid = fopen(testFileName);
tline = fgetl(fid);

while ( ischar(tline) ) 
    k_lsf = strcat(tline, '.lsf');
    k_ema = strcat(tline, '.ema');
    [lsf, ~, ~] = estload(k_lsf);
    [ema, ~, ~] = estload(k_ema);

    for j = 1:size(lsf,1)
        for k = 1:10
            test_x = [test_x; lsf(j,(k-1)*41+1:k*41)];
            test_y = [test_y; ema(j,1:12)];
        end
    end
    t = toc;
    disp(strcat(tline, ' ... ', num2str(t)));
    tline = fgetl(fid);
end
fclose(fid);
t = toc;

disp(strcat('Test set extraction took ', num2str(t), 'seconds'));
save('mngu0_prepared', 'train_x', 'train_y', 'valid_x', 'valid_y', ...
    'test_x', 'test_y');