
close all
clear
clc

matFileName = 'trainOutput';
outFileName = strcat(matFileName, '.txt');

OutTrain = []; %output matrix before z-scoring
LabelsTrain = []; %output matrix for labels

OutTest = []; %output matrix before z-scoring
LabelsTest = []; %output matrix for labels

OutValid = []; %output matrix before z-scoring
LabelsValid = []; %output matrix for labels

frameSize = 110;
FS_sig = 22050;
FS_ema = 100.0805;
frame_ema = 20*frameSize*(FS_ema/FS_sig); %converting from wav sample to ema sample
hamWin = hamming(frameSize);

for j = 20:50
    tic;
    infileName = strcat('usctimit_ema_f5_', num2str(j*5+1), '_', num2str((j+1)*5));

    sig = load(infileName,'-mat');

    c = struct2cell(sig);
    input = c{1}(1,1).SIGNAL(:,1);
    sigLen = length(input);
    frames = floor(sigLen/frameSize);
   
    counter = 0;
    for i = 1:(frames/2 - 10) % -5 because the duration of the ema and the wav is not equal
        % Estimate lsf of frame
        currentTemp = input((counter)*(frameSize)+1:(counter+1)*frameSize);
        current = hamWin.*filter([1 -0.95],1,currentTemp);

        [Y, sigA, sigacf] = getLsfParameters(current, 40);

        % Get label points
        labelCounter = floor(counter/20);
        labelSample = floor(labelCounter*frame_ema + frame_ema/2);
        labels = getLabelsEma(sig, labelSample);

        OutTrain = [OutTrain; Y'];
        LabelsTrain = [LabelsTrain; labels];
        counter = counter + 2;
    end
    j
    t = toc
end

for j = 51:56 %number of files
    tic
    infileName1 = strcat('usctimit_ema_f5_', num2str(j*5+1), '_', num2str((j+1)*5));
    sig1 = load(infileName1,'-mat');

    c = struct2cell(sig1);
    input = c{1}(1,1).SIGNAL(:,1);
    sigLen = length(input);
    frames = floor(sigLen/frameSize);

    counter = 0;
    for i = 1:(frames/2 - 10) % -5 because the duration of the ema and the wav is not equal
    % Estimate lsf of frame
    currentTemp = input((counter)*(frameSize)+1:(counter+1)*frameSize);
    current = hamWin.*filter([1 -0.95],1,currentTemp);

    [Y, sigA, sigacf] = getLsfParameters(current, 40);

    % Get label points
    labelCounter = floor(counter/20);
    labelSample = floor(labelCounter*frame_ema + frame_ema/2);
    labels = getLabelsEma(sig, labelSample);

    OutTest = [OutTest; Y'];
    LabelsTest = [LabelsTest; labels];
    counter = counter + 2;
    end
    j
    t = toc
end

test_x = zscore(OutTest);
test_y = LabelsTest;
train_x = zscore(OutTrain);
train_y = LabelsTrain;
% dlmwrite(outFileName, output, 'delimiter', ' ', 'precision', 4, '-append');
save(matFileName, 'train_x', 'train_y', 'test_x', 'test_y');

t = toc


% figure
% plot(sigA), title('AcLevinson');
% hold on 
% plot(Y, 'r');