function [er, nn] = nntest(nn, x, y)
    
    % Estimate predictions
    [labels, nn] = nnpredict(nn, x);
    
    % Filter predictions
    filt = fir1(30,0.1);
    activations = [];
    for i = 1:size(labels{end},2)
        activations = [activations filter(filt,1,labels{end}(:,i))];
    end
    difference = (y-activations);
    
    %Plotting the estimated trajectory versus the real and also plotting
    %the difference in a separate subplot
    figure
    subplot(2,1,1)
    plot(y(:,1), 'r'), title('Estimated trajectory vs. target'), ...
        xlabel('sample'), ylabel('Position [cm]');
    hold on
    plot(activations(:,1), 'b');
    subplot(2,1,2)
    plot(abs(difference(:,1))), title('Absolute difference'), ...
        xlabel('sample'), ylabel('Absolute diff [cm]')
    
    % Multiply by the standard deviations from before z-scoring to obtain
    % the error in cm
    load('ema_stds.mat');
    for i = 1:size(y,1)
        difference(i,:) = difference(i,:) .* (4*stds(1:12));
    end
    er =  sqrt(mean(difference .^ 2)); 
    
end
