function [er, nn] = test_DBN_NN
% Runs pre-training, training and test phase

% mngu0_prepared is a small dataset used as a dummy for fast results
load mngu0_prepared;
train_x = double(train_x);
test_x = double(test_x);
% valid_x = double(valid_x);
train_y = double(train_y);
test_y  = double(test_y);
% valid_y = double(valid_y);


%%  train a 300-300-300 hidden unit DBN and use its weights to initialize 
%   an NN
rand('state',0)
%% Train DBN
dbn.sizes = [300];
opts.numepochs =   300;
opts.batchsize =   100;
opts.momentum  =   0.5;
opts.alpha     =   0.1;
opts.weightDecay = 0.0001;
dbn = dbnsetup(dbn, train_x, opts);
dbn = dbntrain(dbn, train_x, opts);

%% The following three lines are used to save and load pre-trained DBNs
% save('dbn_trained_400k', 'dbn', '-v7.3');
% nn=0;
% load('dbn_trained_400k');

%% unfold dbn to nn
nn = dbnunfoldtonn(dbn, 12, train_x, train_y); 

%% DropoutFraction only used in case of dropout training.
% nn.dropoutFraction = 0.5;

%% train nn
opts.numepochs =   300;
opts.batchsize =   100;
nn = nntrain(nn, train_x, train_y, opts);

%% test nn
[er, nn] = nntest(nn, test_x, test_y);

% assert(er < 0.2, 'Too big error');
